<template>
  <tbody class="table-body" :data-group-id="group.id">
    <template v-for="(row, index) in rows">
      <sa-table-row
        v-if="row"
        :key="row.index"
        class="row-data"
        :columns="columns"
        :row="row"
        :cell-type="cellType"
        :cell-props="cellProps"
      />
      <tr
        v-else
        :key="'missing-' + index"
        class="table-row row-spacer"
        :style="{ height: spacerHeight + 'px' }"
      >
        <td v-for="column in columns" :key="column.key">
          <div></div>
        </td>
      </tr>
    </template>
  </tbody>
</template>

<script>
import SaTableRow from './SaTableRow'

export default {
  name: 'SaTableBody',
  components: { SaTableRow },
  props: {
    group: {
      type: Object,
      required: true
    },
    columns: {
      type: Array,
      required: true
    },
    allRows: {
      type: Array,
      required: true
    },
    cellType: {
      type: Function,
      required: true
    },
    cellProps: {
      type: Function,
      required: true
    },
    spacerHeight: {
      type: Number,
      required: true
    }
  },
  computed: {
    rows() {
      return this.allRows.slice(
        this.group.firstRowIndex,
        this.group.lastRowIndex + 1 // index is inclusive
      )
    }
  }
}
</script>

<style lang="scss" scoped>
@keyframes row-spacer {
  0% {
    background-position-x: 50%;
  }
  100% {
    background-position-x: -80%;
  }
}

.row-spacer {
  td {
    height: 1px;
    padding: spacing(1) spacing(1) spacing(1) 0;

    @-moz-document url-prefix() {
      height: 100% !important;
    }

    div {
      width: 100%;
      height: 100%;
      animation: row-spacer 1.5s linear infinite;
      background-image: linear-gradient(
        135deg,
        color(grey-tint) 10%,
        rgba(color(grey-tint), 0.25) 20%,
        color(grey-tint) 30%
      );
      background-size: 200% 100%;
      background-position: 50% 0;
    }
  }
}
</style>
